Package org.apache.catalina.manager

# Class JMXProxyServlet

java.lang.Object
jakarta.servlet.GenericServlet
jakarta.servlet.http.HttpServlet
org.apache.catalina.manager.JMXProxyServlet

All Implemented Interfaces:
  `Servlet`, `ServletConfig`, `Serializable`

public class JMXProxyServlet extends HttpServlet
This servlet will dump JMX attributes in a simple format and implement proxy services for modeler.

Author:
  Costin Manolache
See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`protected MBeanServer`
`mBeanServer`
MBean server.
`protected Registry`
`registry`

### Fields inherited from class jakarta.servlet.http.HttpServlet

`LEGACY_DO_HEAD`

## Constructor Summary

Constructors
Constructor
Description
`JMXProxyServlet()`

## Method Summary

Modifier and Type
Method
Description
`void`
`doGet(HttpServletRequest request, HttpServletResponse response)`
Called by the server (via the `service` method) to allow a servlet to handle a GET request.
`void`
`getAttribute(PrintWriter writer, String onameStr, String att, String key)`
`void`
`init()`
A convenience method which can be overridden so that there's no need to call `super.init(config)`.
`boolean`
`isSupported(String type)`
Determines if a type is supported by the `JMXProxyServlet`.
`void`
`listBeans(PrintWriter writer, String qry)`
`void`
`setAttribute(PrintWriter writer, String onameStr, String att, String val)`

### Methods inherited from class jakarta.servlet.http.HttpServlet

`doDelete, doHead, doOptions, doPost, doPut, doTrace, getLastModified, init, service, service`

### Methods inherited from class jakarta.servlet.GenericServlet

`destroy, getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletInfo, getServletName, log, log`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### mBeanServer

protected transient MBeanServer mBeanServer
MBean server.

### registry

protected transient Registry registry

## Constructor Details

### JMXProxyServlet

public JMXProxyServlet()

## Method Details

### init

public void init() throws ServletException
Description copied from class: `jakarta.servlet.GenericServlet`
A convenience method which can be overridden so that there's no need to call `super.init(config)`.

Instead of overriding `GenericServlet.init(ServletConfig)`, simply override this method and it will be called by `GenericServlet.init(ServletConfig config)`. The `ServletConfig` object can still be retrieved via `GenericServlet.getServletConfig()`.

Overrides:
  `init` in class `GenericServlet`
Throws:
  `ServletException` - if an exception occurs that interrupts the servlet's normal operation

### doGet

public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
Description copied from class: `jakarta.servlet.http.HttpServlet`
Called by the server (via the `service` method) to allow a servlet to handle a GET request.

Overriding this method to support a GET request also automatically supports an HTTP HEAD request. A HEAD request is a GET request that returns no body in the response, only the request header fields.

When overriding this method, read the request data, write the response headers, get the response's Writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

The GET method should be safe, that is, without any side effects for which users are held responsible. For example, most form queries have no side effects. If a client request is intended to change stored data, the request should use some other HTTP method.

The GET method should also be idempotent, meaning that it can be safely repeated. Sometimes making a method safe also makes it idempotent. For example, repeating queries is both safe and idempotent, but buying a product online or modifying data is neither safe nor idempotent.

If the request is incorrectly formatted, `doGet` returns an HTTP "Bad Request" message.

Overrides:
  `doGet` in class `HttpServlet`
Parameters:
  `request` - an `HttpServletRequest` object that contains the request the client has made of the servlet
  `response` - an `HttpServletResponse` object that contains the response the servlet sends to the client
Throws:
  `IOException` - if an input or output error is detected when the servlet handles the GET request
  `ServletException` - if the request for the GET could not be handled
See Also:
  - `ServletResponse.setContentType(java.lang.String)`

### getAttribute

public void getAttribute(PrintWriter writer, String onameStr, String att, String key)

### setAttribute

public void setAttribute(PrintWriter writer, String onameStr, String att, String val)

### listBeans

public void listBeans(PrintWriter writer, String qry)

### isSupported

public boolean isSupported(String type)
Determines if a type is supported by the `JMXProxyServlet`.

Parameters:
  `type` - The type to check
Returns:
  Always returns `true`